package salsa.language;

import wwc.naming.UAL;

public class Messenger extends UniversalActor {
    Message message;

    public Messenger(Message message) {
        this.message = message;
    }

    public void act() {
        message.getTarget().send(message);
    }

    public void go() throws MigrationException {
        UAL targetUAL = ((UniversalActor)message.getTarget()).getUAL();
		// migrate it to target's stage:
		// cvarela:  make sure /Messenger/Thread-  is unique at target stage!
        try {
            bind(null,
            		new UAL("rmsp://"
			            	+targetUAL.getHost()
			            	+":"+targetUAL.getPort()
			            	+"/Messenger/"
			            	+this.getName()));
        } catch (Exception e) {
			// cvarela: try with the UAN!!!
            throw new MigrationException(e.getMessage());
        }
    }

    public void updateReferences(){
        message.updateReferences();
    }
}
