package wwc.messaging;

import java.io.*;
import java.net.*;
import salsa.language.*;
import wwc.naming.UAL;

public class RmspdTest {
    static StandardOutput stdOut = new StandardOutput();
    static int i=0;
    public static void main(String args[]) {   
	try {
	    UniversalActor a = new UniversalActor();
	    a.bind("uan://yangtze.cs.uiuc.edu:3030/a",
		   "rmsp://yangtze.cs.uiuc.edu:4040/a");
	    UniversalActor b = new UniversalActor();
	    b.bind("uan://yangtze.cs.uiuc.edu:3030/b",
		   "rmsp://yangtze.cs.uiuc.edu:4040/b");

	    UAL targetUAL = new UAL("rmsp://mekong.cs.uiuc.edu:4040/test");
	    String localHost = InetAddress.getLocalHost().getHostName();
	    IncomingActorNotification ian = new IncomingActorNotification(localHost,
									  6666,
									  "relativeUAL/jkl",
									  23456);

	    UnbindRequest ean = new UnbindRequest(localHost,
						  6667,
						  "relativeUAL/jkl");
	    
	    Socket s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    ObjectOutputStream out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(ian);
	    out.close();
	    s.close();

	    s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(ean);
	    out.close();
	    s.close();

	    s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(a);
	    out.close();
	    s.close();

	    s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(b);
	    out.close();
	    s.close();


	    s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(new Integer(0));
	    out.close();
	    s.close();

	    Object[][] arguments = { {"rmsp://yangtze.cs.uiuc.edu:4040/agent"}, {"uan://yangtze.cs.uiuc.edu:3030/agent", "rmsp://yangtze.cs.uiuc.edu:4040/agent"}, {args, new Integer(0)} };	
	    s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(arguments);
	    out.close();
	    s.close();

	    s = new Socket(targetUAL.getHost(), targetUAL.getPort());
	    out = new ObjectOutputStream(new BufferedOutputStream(s.getOutputStream()));
	    out.writeObject(stdOut);
	    out.close();
	    s.close();
	    a.die(); b.die();

	} catch (Exception e) {
	    System.out.println(e);
	}
    }
}
 
